package com.fp.persistence.pbpm.gene;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.util.List;

import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.Query;
import javax.persistence.Table;
import javax.persistence.Transient;

import com.fp.dto.hb.HibernateBean;

/** Clase que implementa la entidad de Hibernate que hace referencia a la tabla TBPMFIELDTRANSACTIONORIGIN */
@Entity(name = "TbpmFieldTransactionOrigin")
@Table(name = "TBPMFIELDTRANSACTIONORIGIN")
public class TbpmFieldTransactionOrigin extends com.fp.dto.AbstractDataTransport implements Serializable,
        HibernateBean, Cloneable {
    /**
     * HashCode asociado con la Instancia
     */
    @Transient
    private int hashValue = 0;

    /**
     * Version de la Clase
     */
    private static final long serialVersionUID = 1L;

    /**
     * Clave primaria de la Entidad TbpmFieldTransactionOrigin
     */
    @EmbeddedId
    private TbpmFieldTransactionOriginKey pk;

    @Column(name = "EXPRESIONLANGUAGE", nullable = true)
    /**
     * Expresion language que entrega el valor del campo
     */
    private String expresionlanguage;

    /** Contructor por defecto */
    public TbpmFieldTransactionOrigin() {
    }

    /**
     * Contructor de TbpmFieldTransactionOrigin
     * 
     * @param pPk Clave Primaria del entity
     */
    public TbpmFieldTransactionOrigin(TbpmFieldTransactionOriginKey pPk) {
        this();
        this.pk = pPk;
    }

    /**
     * Metodo que entrega datos de la tabla dada la clave primaria.
     * 
     * @param pEntityManager referencia de la session a obtener datos del bean.
     * @param pKey Caleve primaria del bean.
     * @return TbpmFieldTransactionOrigin
     */
    public static TbpmFieldTransactionOrigin find(EntityManager pEntityManager, TbpmFieldTransactionOriginKey pKey)
            throws Exception {
        TbpmFieldTransactionOrigin obj = pEntityManager.find(TbpmFieldTransactionOrigin.class, pKey);
        return obj;
    }

    /**
     * Entrega la Clave primaria de TbpmFieldTransactionOrigin
     * 
     * @return El objeto que referencia a la Clave primaria de TbpmFieldTransactionOrigin
     */
    public TbpmFieldTransactionOriginKey getPk() {
        return this.pk;
    }

    /**
     * Fija un nuevo valor a la Clave primaria de TbpmFieldTransactionOrigin
     * 
     * @param pPk El objeto que referencia a la nueva Clave primaria de TbpmFieldTransactionOrigin
     */
    public void setPk(TbpmFieldTransactionOriginKey pPk) {
        this.pk = pPk;
    }

    /**
     * Obtiene el valor de expresionlanguage
     * 
     * @return valor de expresionlanguage
     */
    public String getExpresionlanguage() {
        return this.expresionlanguage;
    }

    /**
     * Fija el valor de expresionlanguage
     * 
     * @param pExpresionlanguage nuevo Valor de expresionlanguage
     */
    public void setExpresionlanguage(String pExpresionlanguage) {
        this.expresionlanguage = pExpresionlanguage;
    }

    @Override
    public boolean equals(Object rhs) {
        if (rhs == null) {
            return false;
        }
        if (!(rhs instanceof TbpmFieldTransactionOrigin)) {
            return false;
        }
        TbpmFieldTransactionOrigin that = (TbpmFieldTransactionOrigin) rhs;
        if ((this.getPk() == null) || (that.getPk() == null)) {
            return false;
        }
        return (this.getPk().equals(that.getPk()));
    }

    /**
     * Implementaci�n del metodo hashCode de la la entidad TbpmFieldTransactionOrigin
     * 
     * @return el hashCode la instancia
     */
    @Override
    public int hashCode() {
        if (this.hashValue == 0) {
            int result = 17;
            if (this.getPk() == null) {
                result = super.hashCode();
            } else {
                result = this.getPk().hashCode();
            }
            this.hashValue = result;
        }
        return this.hashValue;
    }

    /** Implementaci�n toString */
    @Override
    public String toString() {
        Field[] fs = this.getClass().getDeclaredFields();
        String data = "";
        for (Field f : fs) {
            try {
                String name = f.getName();
                if (f.getType().getName().compareTo("java.util.Set") == 0) {
                    continue;
                }
                if ((name.compareTo("hashValue") == 0) || (name.compareTo("serialVersionUID") == 0)) {
                    continue;
                }
                data += name + "=" + f.get(this) + ";";
            } catch (Exception e) {
                continue;
            }
        }
        if (data.compareTo("") == 0) {
            data = super.toString();
        }
        return data;
    }

    /** Implementaci�n de la creaci�n de un bean en blanco TbpmFieldTransactionOrigin */
    @Override
    public Object createInstance() {
        TbpmFieldTransactionOrigin instance = new TbpmFieldTransactionOrigin();
        instance.setPk(new TbpmFieldTransactionOriginKey());
        return instance;
    }

    /**
     * Clona la entidad TbpmFieldTransactionOrigin
     * 
     * @see com.fp.dto.hb.HibernateBean#cloneMe()
     */
    @Override
    public Object cloneMe() throws CloneNotSupportedException {
        TbpmFieldTransactionOrigin p = (TbpmFieldTransactionOrigin) this.clone();
        p.setPk((TbpmFieldTransactionOriginKey) this.pk.cloneMe());
        return p;
    }

    // Metodos manuales.

    /** Sentecia que entrega una lista de TbpmFieldTransactionOrigin dado un codigo de transaccion. */
    private static final String HQL_FIELDS = "from TbpmFieldTransactionOrigin t where t.pk.transactionmodule = :module  "
            + "and t.pk.transactioncode = :transaction and t.pk.transactionversion = :version  ";

    /**
     * Metodo que entrega una lista de registros de la tabla TbpmFieldTransactionOrigin dado un codigo de transaccion.
     * 
     * @param pEntityManager Referencia a la session de la base de datos.
     * @param pGroupcode Codigo de grupo a obtener una lista de usuarios.
     * @return List<TbpmGroupsUsers>
     * @throws Exception
     */
    @SuppressWarnings("unchecked")
    public static List<TbpmFieldTransactionOrigin> find(EntityManager pEntityManager, String pModule,
            Integer pTransaction, Integer pVersion) throws Exception {
        Query qry = pEntityManager.createQuery(TbpmFieldTransactionOrigin.HQL_FIELDS);
        qry.setParameter("module", pModule);
        qry.setParameter("transaction", pTransaction);
        qry.setParameter("version", pVersion);
        return qry.getResultList();

    }
}
